const colors = require("colors");

const colorFunctions = {
  // Regular colors
  red: (text) => colors.red(text),
  green: (text) => colors.green(text),
  blue: (text) => colors.blue(text),
  yellow: (text) => colors.yellow(text),
  magenta: (text) => colors.magenta(text),
  cyan: (text) => colors.cyan(text),
  white: (text) => colors.white(text),
  gray: (text) => colors.gray(text),
  black: (text) => colors.black(text),
  orange: (text) => `\x1b[38;2;255;165;0m${text}\x1b[0m`,
  purple: (text) => `\x1b[38;2;128;0;128m${text}\x1b[0m`,
  pink: (text) => `\x1b[38;2;255;192;203m${text}\x1b[0m`,
  brown: (text) => `\x1b[38;2;165;42;42m${text}\x1b[0m`,
  navy: (text) => `\x1b[38;2;0;0;128m${text}\x1b[0m`,
  teal: (text) => `\x1b[38;2;0;128;128m${text}\x1b[0m`,
  maroon: (text) => `\x1b[38;2;128;0;0m${text}\x1b[0m`,
  olive: (text) => `\x1b[38;2;128;128;0m${text}\x1b[0m`,
  lime: (text) => `\x1b[38;2;0;255;0m${text}\x1b[0m`,
  coral: (text) => `\x1b[38;2;255;127;80m${text}\x1b[0m`,
  salmon: (text) => `\x1b[38;2;250;128;114m${text}\x1b[0m`,
  gold: (text) => `\x1b[38;2;255;215;0m${text}\x1b[0m`,
  indigo: (text) => `\x1b[38;2;75;0;130m${text}\x1b[0m`,
  turquoise: (text) => `\x1b[38;2;64;224;208m${text}\x1b[0m`,
  violet: (text) => `\x1b[38;2;238;130;238m${text}\x1b[0m`,
  plum: (text) => `\x1b[38;2;221;160;221m${text}\x1b[0m`,
  khaki: (text) => `\x1b[38;2;240;230;140m${text}\x1b[0m`,
  crimson: (text) => `\x1b[38;2;220;20;60m${text}\x1b[0m`,
  orchid: (text) => `\x1b[38;2;218;112;214m${text}\x1b[0m`,
  sienna: (text) => `\x1b[38;2;160;82;45m${text}\x1b[0m`,
  tan: (text) => `\x1b[38;2;210;180;140m${text}\x1b[0m`,
  chocolate: (text) => `\x1b[38;2;210;105;30m${text}\x1b[0m`,
  peru: (text) => `\x1b[38;2;205;133;63m${text}\x1b[0m`,
  indianRed: (text) => `\x1b[38;2;205;92;92m${text}\x1b[0m`,
  darkGreen: (text) => `\x1b[38;2;0;100;0m${text}\x1b[0m`,
  darkBlue: (text) => `\x1b[38;2;0;0;139m${text}\x1b[0m`,
  darkRed: (text) => `\x1b[38;2;139;0;0m${text}\x1b[0m`,
  darkCyan: (text) => `\x1b[38;2;0;139;139m${text}\x1b[0m`,
  darkMagenta: (text) => `\x1b[38;2;139;0;139m${text}\x1b[0m`,
  darkOrange: (text) => `\x1b[38;2;255;140;0m${text}\x1b[0m`,
  darkViolet: (text) => `\x1b[38;2;148;0;211m${text}\x1b[0m`,
  darkGray: (text) => `\x1b[38;2;169;169;169m${text}\x1b[0m`,
  lightGray: (text) => `\x1b[38;2;211;211;211m${text}\x1b[0m`,
  lightGreen: (text) => `\x1b[38;2;144;238;144m${text}\x1b[0m`,
  lightBlue: (text) => `\x1b[38;2;173;216;230m${text}\x1b[0m`,
  lightPink: (text) => `\x1b[38;2;255;182;193m${text}\x1b[0m`,
  lightSalmon: (text) => `\x1b[38;2;255;160;122m${text}\x1b[0m`,
  lightCoral: (text) => `\x1b[38;2;240;128;128m${text}\x1b[0m`,
  lightSkyBlue: (text) => `\x1b[38;2;135;206;250m${text}\x1b[0m`,

  // Bright colors
  brightRed: (text) => colors.brightRed(text),
  brightGreen: (text) => colors.brightGreen(text),
  brightBlue: (text) => colors.brightBlue(text),
  brightYellow: (text) => colors.brightYellow(text),
  brightMagenta: (text) => colors.brightMagenta(text),
  brightCyan: (text) => colors.brightCyan(text),
  brightWhite: (text) => colors.brightWhite(text),

  // Background colors
  bgRed: (text) => colors.bgRed(text),
  bgGreen: (text) => colors.bgGreen(text),
  bgBlue: (text) => colors.bgBlue(text),
  bgYellow: (text) => colors.bgYellow(text),
  bgMagenta: (text) => colors.bgMagenta(text),
  bgCyan: (text) => colors.bgCyan(text),
  bgWhite: (text) => colors.bgWhite(text),
  bgBlack: (text) => colors.bgBlack(text),

  // Bright background colors
  bgBrightRed: (text) => colors.bgBrightRed(text),
  bgBrightGreen: (text) => colors.bgBrightGreen(text),
  bgBrightBlue: (text) => colors.bgBrightBlue(text),
  bgBrightYellow: (text) => colors.bgBrightYellow(text),
  bgBrightMagenta: (text) => colors.bgBrightMagenta(text),
  bgBrightCyan: (text) => colors.bgBrightCyan(text),
  bgBrightWhite: (text) => colors.bgBrightWhite(text),

  // Additional colors
  orange: (text) => colors.yellow(colors.red(text)),
  purple: (text) => colors.blue(colors.magenta(text)),
  pink: (text) => colors.magenta(colors.white(text)),
  brown: (text) => colors.yellow(colors.red(colors.dim(text))),
  teal: (text) => colors.green(colors.blue(text)),
  navy: (text) => colors.blue(colors.dim(text)),
  maroon: (text) => colors.red(colors.dim(text)),
  olive: (text) => colors.green(colors.yellow(colors.dim(text))),

  // Additional background colors
  bgOrange: (text) => colors.bgYellow(colors.red(text)),
  bgPurple: (text) => colors.bgBlue(colors.magenta(text)),
  bgPink: (text) => colors.bgMagenta(colors.white(text)),
  bgBrown: (text) => colors.bgYellow(colors.red(colors.dim(text))),
  bgTeal: (text) => colors.bgGreen(colors.blue(text)),
  bgNavy: (text) => colors.bgBlue(colors.dim(text)),
  bgMaroon: (text) => colors.bgRed(colors.dim(text)),
  bgOlive: (text) => colors.bgGreen(colors.yellow(colors.dim(text))),
};

module.exports = colorFunctions;
